/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Surface.xs. Do not edit this file, edit Surface.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "lib/SDLx/Surface.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_newSV_type_GLOBAL
#include "ppport.h"
#include "helper.h"

#ifndef aTHX_
#define aTHX_
#endif

#include <SDL.h>
#include "SDLx/Validate.h"

#ifdef HAVE_SDL_GFX_PRIMITIVES
#include <SDL_gfxPrimitives.h>
#endif

SV * get_pixel32 (SDL_Surface *surface, int x, int y)
{
    /* Convert the pixels to 32 bit  */
    Uint32 *pixels = (Uint32 *)surface->pixels; 
    /* Get the requested pixel  */

    void* s =  pixels + _calc_offset(surface, x, y); 

    /* printf( " Pixel = %d, Ptr = %p \n", *((int*) s), s ); */

    SV* sv = newSV_type(SVt_PV);
    SvPV_set(sv, s);
    SvPOK_on(sv);
    SvLEN_set(sv, 0);
    SvCUR_set(sv, surface->format->BytesPerPixel);
    return newRV_noinc(sv); /* make a modifiable reference using u_ptr's place as the memory :) */
}

SV * construct_p_matrix ( SDL_Surface *surface )
{
    /* return  get_pixel32( surface, 0, 0); */
    AV * matrix = newAV();
    int i, j;
    i = 0;
    for( i =0 ; i < surface->w; i++ )
    {
        AV * matrix_row = newAV();
        for( j =0 ; j < surface->h; j++ )
            av_push( matrix_row, get_pixel32(surface, i,j) );

        av_push( matrix, newRV_noinc((SV *)matrix_row) );
    }

    return newRV_noinc((SV *)matrix);
}

int _calc_offset ( SDL_Surface* surface, int x, int y )
{
    int offset;
    offset  = (surface->pitch * y) / surface->format->BytesPerPixel;
    offset += x;
    return offset;
}

unsigned int _get_pixel(SDL_Surface * surface, int offset)
{
    unsigned int value;
    switch(surface->format->BytesPerPixel)
    {
        case 1: value = ((Uint8  *)surface->pixels)[offset];
                break;
        case 2: value = ((Uint16 *)surface->pixels)[offset];
                break;
        case 3: value = ((Uint32)((Uint8 *)surface->pixels)[offset * surface->format->BytesPerPixel]     <<  0)
                      + ((Uint32)((Uint8 *)surface->pixels)[offset * surface->format->BytesPerPixel + 1] <<  8)
                      + ((Uint32)((Uint8 *)surface->pixels)[offset * surface->format->BytesPerPixel + 2] << 16);
                break;
        case 4: value = ((Uint32 *)surface->pixels)[offset];
                break;
    }
    return value;
}

#line 92 "lib/SDLx/Surface.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 144 "lib/SDLx/Surface.c"

XS(XS_SDLx__Surface_pixel_array); /* prototype to pass -Wmissing-prototypes */
XS(XS_SDLx__Surface_pixel_array)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	SDL_Surface *	surface;
	SV *	RETVAL;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        surface = (SDL_Surface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    };
#line 89 "lib/SDLx/Surface.xs"
        switch(surface->format->BytesPerPixel)
        {
            case 1: croak("Not implemented yet for 8bpp surfaces\n");
                    break;
            case 2: croak("Not implemented yet for 16bpp surfaces\n");
                    break;
            case 3: croak("Not implemented yet for 24bpp surfaces\n");
                    break;
            case 4:
                    RETVAL = construct_p_matrix (surface);
                    break;
        }
#line 181 "lib/SDLx/Surface.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_SDLx__Surface_get_pixel_xs); /* prototype to pass -Wmissing-prototypes */
XS(XS_SDLx__Surface_get_pixel_xs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "surface, x, y");
    {
	SDL_Surface *	surface;
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	unsigned int	RETVAL;
	dXSTARG;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        surface = (SDL_Surface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    };
#line 110 "lib/SDLx/Surface.xs"
        _int_range( &x, 0, surface->w );
        _int_range( &y, 0, surface->h );
        int offset;
        offset = _calc_offset( surface, x, y);
        RETVAL = _get_pixel( surface, offset );
#line 220 "lib/SDLx/Surface.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_SDLx__Surface_set_pixel_xs); /* prototype to pass -Wmissing-prototypes */
XS(XS_SDLx__Surface_set_pixel_xs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "surface, x, y, value");
    {
	SDL_Surface *	surface;
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	unsigned int	value = (unsigned int)SvUV(ST(3));

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        surface = (SDL_Surface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    };
#line 126 "lib/SDLx/Surface.xs"
        _int_range( &x, 0, surface->w );
        _int_range( &y, 0, surface->h );
        int offset;
        offset = _calc_offset( surface, x, y);
        if(SDL_MUSTLOCK(surface) && SDL_LockSurface(surface) < 0)
            croak( "Locking surface in set_pixels failed: %s", SDL_GetError() );
        switch(surface->format->BytesPerPixel)
        {
            case 1: ((Uint8  *)surface->pixels)[offset] = (Uint8)value;
                    break;
            case 2: ((Uint16 *)surface->pixels)[offset] = (Uint16)value;
                    break;
            case 3: ((Uint8  *)surface->pixels)[offset * surface->format->BytesPerPixel]     = (Uint8)( value        & 0xFF);
                    ((Uint8  *)surface->pixels)[offset * surface->format->BytesPerPixel + 1] = (Uint8)((value <<  8) & 0xFF);
                    ((Uint8  *)surface->pixels)[offset * surface->format->BytesPerPixel + 2] = (Uint8)((value << 16) & 0xFF);
                    break;
            case 4: ((Uint32 *)surface->pixels)[offset] = (Uint32)value;
                    break;
        }
        if(SDL_MUSTLOCK(surface))
            SDL_UnlockSurface(surface);
#line 273 "lib/SDLx/Surface.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_SDLx__Surface_draw_rect); /* prototype to pass -Wmissing-prototypes */
XS(XS_SDLx__Surface_draw_rect)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "surface, rt, color");
    {
	SDL_Surface *	surface;
	SV*	rt = ST(1);
	SV*	color = ST(2);

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        surface = (SDL_Surface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    };
#line 154 "lib/SDLx/Surface.xs"
        Uint32 m_color = __map_rgba( color, surface->format );
        SDL_Rect r_rect;

        if( SvOK(rt) )
            r_rect = *(SDL_Rect*)bag2obj( create_mortal_rect( rt ) );
        else
        {
            r_rect.x = 0; r_rect.y = 0; r_rect.w = surface->w; r_rect.h = surface->h;
        }
        SDL_FillRect(surface, &r_rect, m_color);
#line 313 "lib/SDLx/Surface.c"
    }
    XSRETURN_EMPTY;
}

#ifdef HAVE_SDL_GFX_PRIMITIVES
#define XSubPPtmpAAAA 1


XS(XS_SDLx__Surface_draw_polygon); /* prototype to pass -Wmissing-prototypes */
XS(XS_SDLx__Surface_draw_polygon)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       croak_xs_usage(cv,  "surface, vectors, color, ...");
    {
	SV*	surface = ST(0);
	AV*	vectors;
	Uint32	color = (Uint32)SvUV(ST(2));
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    vectors = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"SDLx::Surface::draw_polygon",
				"vectors");
		}
	} STMT_END;
#line 173 "lib/SDLx/Surface.xs"
        SDL_Surface * _surface = (SDL_Surface *)bag2obj(surface);
        AV* vx                 = newAV();
        AV* vy                 = newAV();
        AV* vertex;
        while(av_len(vectors) >= 0)
        {
            vertex = (AV*)SvRV(av_shift(vectors));
            av_push(vx, av_shift(vertex));
            av_push(vy, av_shift(vertex));
        }

        int n          = av_len(vx) + 1;
        Sint16 * _vx   = av_to_sint16(vx);
        Sint16 * _vy   = av_to_sint16(vy);
        if ( items > 3 && SvTRUE( ST(3) ) )
            aapolygonColor( _surface, _vx, _vy, n, color );
        else
            polygonColor( _surface, _vx, _vy, n, color );
        _svinta_free( _vx, av_len(vx) );
        _svinta_free( _vy, av_len(vy) );
        RETVAL = SvREFCNT_inc(surface); // why SvREFCNT_inc?
#line 372 "lib/SDLx/Surface.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif

XS(XS_SDLx__Surface_blit); /* prototype to pass -Wmissing-prototypes */
XS(XS_SDLx__Surface_blit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "src, dest, ...");
    {
	SV *	src = ST(0);
	SV *	dest = ST(1);
#line 204 "lib/SDLx/Surface.xs"
        assert_surface(src);
        assert_surface(dest);
        /* just return the pointer stored in the bag */
        SDL_Surface *_src  = (SDL_Surface *)bag2obj(src);
        SDL_Surface *_dest = (SDL_Surface *)bag2obj(dest);

        SDL_Rect _src_rect;
        SDL_Rect _dest_rect;

        if( items > 2 && SvOK(ST(2)) )
            _src_rect = *(SDL_Rect *)bag2obj( create_mortal_rect( ST(2) ) );
        else
        {
            _src_rect.x = 0;
            _src_rect.y = 0;
            _src_rect.w = _src->w;
            _src_rect.h = _src->h;
        }

        if( items > 3 && SvOK(ST(3)) )
            _dest_rect = *(SDL_Rect *)bag2obj( create_mortal_rect( ST(3) ) );
        else
        {
            _dest_rect.x = 0;
            _dest_rect.y = 0;
            _dest_rect.w = _dest->w;
            _dest_rect.h = _dest->h;
        }

        SDL_BlitSurface( _src, &_src_rect, _dest, &_dest_rect );
#line 425 "lib/SDLx/Surface.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_SDLx__Surface); /* prototype to pass -Wmissing-prototypes */
XS(boot_SDLx__Surface)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        newXS("SDLx::Surface::pixel_array", XS_SDLx__Surface_pixel_array, file);
        newXS("SDLx::Surface::get_pixel_xs", XS_SDLx__Surface_get_pixel_xs, file);
        newXS("SDLx::Surface::set_pixel_xs", XS_SDLx__Surface_set_pixel_xs, file);
        newXS("SDLx::Surface::draw_rect", XS_SDLx__Surface_draw_rect, file);
#if XSubPPtmpAAAA
        newXS("SDLx::Surface::draw_polygon", XS_SDLx__Surface_draw_polygon, file);
#endif
        newXS("SDLx::Surface::blit", XS_SDLx__Surface_blit, file);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#if XSubPPtmpAAAB
#endif
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAA
#endif
#line 525 "lib/SDLx/Surface.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

